apiVersion: {{ ingress_apivers }}
kind: {{ ingress_kind }}
metadata:
{% if route_custom_timeout | default(False) or route_root | default(False) or k8s_flavor == 'kubernetes' %}
  annotations:
{% if k8s_flavor == 'kubernetes' and (ingress_flavor | default('nginx')) == 'nginx' %}
    nginx.ingress.kubernetes.io/affinity: cookie
{% if route_root | default(False) %}
    nginx.ingress.kubernetes.io/app-root: {{ route_root }}
{% endif %}
{% if route_tls_termination | default('edge') in [ 'passthrough', 'reencrypt' ] %}
    nginx.ingress.kubernetes.io/backend-protocol: HTTPS
{% endif %}
{% if deny_paths | default(False) %}
    nginx.ingress.kubernetes.io/configuration-snippet: |
{% for p in deny_paths %}
      location {{ p }} {
          deny all;
          return 403;
      }
{% endfor %}
{% endif %}
{% if route_cors | default(False) %}
    nginx.ingress.kubernetes.io/enable-cors: "true"
    nginx.ingress.kubernetes.io/cors-allow-credentials: "true"
{% if (route_cors_headers | default([])) | length > 0 %}
    nginx.ingress.kubernetes.io/cors-allow-headers: {{ route_cors_headers | join(',') }}
{% endif %}
    nginx.ingress.kubernetes.io/cors-allow-methods: "PUT, GET, POST, OPTIONS"
    nginx.ingress.kubernetes.io/cors-allow-origin: "{{ 'https' if ((route_tls_termination | default('edge')) != False) else 'http' }}://{{ route_host }}"
{% endif %}
{% if route_body_max_size | default(False) %}
    nginx.ingress.kubernetes.io/proxy-body-size: {{ route_body_max_size }}m
{% endif %}
{% if not (route_request_buffering | default(True)) %}
    nginx.ingress.kubernetes.io/proxy-request-buffering: "off"
{% endif %}
{% if route_custom_timeout | default(False) %}
    nginx.ingress.kubernetes.io/proxy-connect-timeout: {{ route_custom_timeout }}
    nginx.ingress.kubernetes.io/proxy-read-timeout: {{ route_custom_timeout }}
    nginx.ingress.kubernetes.io/proxy-send-timeout: {{ route_custom_timeout }}
{% endif %}
    nginx.ingress.kubernetes.io/session-cookie-name: {{ (cookie_name | default(route_name)) | upper }}
    nginx.ingress.kubernetes.io/session-cookie-expires: "{{ cookie_lifetime | default(172800) }}"
    nginx.ingress.kubernetes.io/session-cookie-max-age: "{{ cookie_lifetime | default(172800) }}"
{% if route_tls_termination | default('edge') == 'passthrough' %}
    nginx.ingress.kubernetes.io/ssl-passthrough: "true"
{% endif %}
{% if route_tls_insecure_policy | default('Redirect') == 'Redirect' %}
    nginx.ingress.kubernetes.io/ssl-redirect: "true"
{% else %}
    nginx.ingress.kubernetes.io/ssl-redirect: "false"
{% endif %}
{% elif k8s_flavor == 'kubernetes' and (ingress_flavor | default('nginx')) == 'traefik' %}
{% if route_tls_insecure_policy | default('Redirect') == 'Redirect' %}
{% if route_root | default(False) %}
    traefik.ingress.kubernetes.io/router.middlewares: {{ namespace }}-{{ route_name }}-https@kubernetescrd
{% else %}
    traefik.ingress.kubernetes.io/router.middlewares: {{ namespace }}-force-https-redirect@kubernetescrd
{% endif %}
{% elif route_root | default(False) %}
    traefik.ingress.kubernetes.io/router.middlewares: {{ namespace }}-{{ route_name }}-add-prefix@kubernetescrd
{% endif %}
{% if route_tls_termination | default('edge') in [ 'passthrough', 'reencrypt' ] %}
    traefik.ingress.kubernetes.io/service.serversscheme: https
{% endif %}
    traefik.ingress.kubernetes.io/service.sticky.cookie: "true"
    traefik.ingress.kubernetes.io/service.sticky.cookie.name: {{ (cookie_name | default(route_name)) | upper }}
{% if route_tls_termination | default('edge') == 'passthrough' %}
    #FIXME: sounds like we need an IngressRoute, Router, maybe some TLSOptions, ....
{% endif %}
{% elif k8s_flavor == 'kubernetes' and (ingress_flavor | default('nginx')) != 'nginx' %}
{% if route_tls_termination | default('edge') == 'passthrough' %}
    ingress.kubernetes.io/ssl-passthrough: "true"
{% endif %}
{% if route_tls_insecure_policy | default('Redirect') == 'Redirect' %}
    ingress.kubernetes.io/ssl-redirect: "true"
{% else %}
    ingress.kubernetes.io/ssl-redirect: "false"
{% endif %}
{% elif k8s_flavor == 'openshift' %}
{% if route_root | default(False) %}
    haproxy.router.openshift.io/rewrite-target: {{ route_root }}
{% endif %}
{% if route_custom_timeout | default(False) %}
    haproxy.router.openshift.io/timeout: {{ route_custom_timeout }}
{% endif %}
{% endif %}
{% endif %}
  name: "{{ route_name }}"
  namespace: "{{ namespace }}"
spec:
{% if ingress_kind == 'Route' %}
  host: {{ route_host }}
  path: {{ route_path | default('/') }}
{% if route_target_port | default(False) %}
  port:
    targetPort: tcp-{{ route_target_port }}
{% endif %}
  to:
    kind: Service
    name: {{ svc_name }}
{% if (route_tls_termination | default('edge')) != False %}
  tls:
    insecureEdgeTerminationPolicy: {{ route_tls_insecure_policy | default('Redirect') }}
    termination: {{ route_tls_termination | default('edge') }}
{% endif %}
{% else %}
{% if has_ig is defined %}
  ingressClassName: {{ has_ig }}
{% endif %}
  rules:
  - http:
      paths:
      - backend:
          service:
            name: {{ svc_name }}
            port:
{% if route_target_port | default(False) %}
              number: {{ route_target_port }}
{% elif has_route_svc is defined and has_route_svc.resources is defined and (has_route_svc.resources | length) > 0 %}
              number: {{ has_route_svc.resources[0].spec.ports[0].port | default(8080) }}
{% else %}
              number: 8080
{% endif %}
        pathType: Prefix
        path: {{ route_path | default('/') }}
    host: {{ route_host }}
{% if (route_tls_termination | default('edge')) != False %}
  tls:
  - hosts:
    - {{ route_host }}
    secretName: {{ route_secret_name | default(route_name) }}-tls
{% endif %}
{% endif %}
